/********************************************************************
file:       utility.cpp

  purpose:    misc utility functions
*********************************************************************/


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Includes
//
#include "utility.h"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// center dialog
//
void CenterDialog()
{
    // try to center the dialog on screen
    HWND hDialog = GetForegroundWindow();
    
    // make sure we're a dialog window... even though we don't know which
    char szBuffer[64];
    GetClassName(hDialog, szBuffer, 64);
    if (!strcmp(szBuffer, "#32770"))
    {
        RECT rc;
        GetWindowRect(hDialog, &rc);
        
        SetWindowPos(hDialog, HWND_TOP,
            (GetSystemMetrics(SM_CXSCREEN) - (rc.right - rc.left)) / 2,
            (GetSystemMetrics(SM_CYSCREEN) - (rc.bottom - rc.top)) / 2, 
            0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOSENDCHANGING
            | SWP_SHOWWINDOW | SWP_NOOWNERZORDER | SWP_NOACTIVATE); // probably overkill
    }
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// get the handle to the AL window
//
HWND GetAlbumListWnd()
{
    return FindWindow("Winamp AL", NULL);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// post a WM_USER message to AL
//
BOOL PostALMessage(IN WPARAM wParam, IN LPARAM lParam)
{
    BOOL bReturn = FALSE;
    HWND hAL = GetAlbumListWnd();
    
    if (IsWindow(hAL))
    {
        bReturn = PostMessage(hAL, WM_AL_IPC, wParam, lParam);
    }
    
    return bReturn;    
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// send a WM_USER message to AL
//
LRESULT SendALMessage(IN WPARAM wParam, IN LPARAM lParam)
{
    LRESULT lReturn = 0;
    HWND hAL = GetAlbumListWnd();
    
    if (IsWindow(hAL))
    {
        lReturn = SendMessage(hAL, WM_AL_IPC, wParam, lParam);
    }
    
    return lReturn;    
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// post a WM_COMMAND message to AL
//
BOOL PostALCmdMessage(IN WORD wMessage)
{
    BOOL bReturn = FALSE;
    HWND hAL = GetAlbumListWnd();
    
    if (IsWindow(hAL))
    {
        bReturn = PostMessage(hAL, WM_COMMAND, MAKEWPARAM(wMessage, 0), 0);
    }

    return bReturn;    
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// send a WM_COMMAND message to AL
//
LRESULT SendALCmdMessage(IN WORD wMessage)
{
    LRESULT lReturn = 0;
    HWND hAL = GetAlbumListWnd();
    
    if (IsWindow(hAL))
    {
        lReturn = SendMessage(hAL, WM_COMMAND, MAKEWPARAM(wMessage, 0), 0);
    }
    
    return lReturn;    
}